<?php

/**
 * inf_nov_kardex_hist actions.
 *
 * @package    nomina
 * @subpackage inf_nov_kardex_hist
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nov_kardex_histActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by codtip, num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $anho_mes_ini = $request['anho_mes_ini'];
            $anho_mes_fin = $request['anho_mes_fin'];
            $periodo = $request['id_periodo'];
            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //whereTipoNovKa
            if (isset($request['id_tip_nov_ka'])) {
                $whereTipoNovKa = " AND tab0.id_tip_nov_ka = " . $request['id_tip_nov_ka'];
            } else {
                $whereTipoNovKa = ' ';
            }
            //funcionario
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            } else {
                $whereEstado = ' ';
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select
tab0.*

    from(

    select
    tab1.*,
    tab2.codigo as codtip,
    tab2.descripcion as descripcion,
    tab2.codigo || ' - ' || tab2.descripcion as completo_tipka,
    tab3.nombre_apellido AS nombre_apellido,
    per.anho_mes,
    per.periodo,
    per.id_tipo_periodo,
    cpnka.id_concep_nomina,
    liqnom.num_dias as dias_liq,
    liqnom.valor_liquidado as valor_liq,
    maefon.codigo,
    maefon.razon_social,
    maefon.codigo || ' - ' || maefon.razon_social as eps_per

    from no_novedad_kardex tab1

    left join no_tip_nov_ka tab2
    on tab2.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join no_datos_funcionario_v tab3
    on tab3.id_tipo_doc = tab1.id_tipo_doc
    and tab3.num_doc = tab1.num_doc

    left join no_periodo_v per
    on per.id_periodo = tab1.id_periodo
    
    left join no_concep_ka cpnka
    on cpnka.id_tip_nov_ka = tab1.id_tip_nov_ka
    
    left join no_liquida_nomina liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    
    left join no_liquida_aporte liqapo
    on liqapo.id_clase_fondo = 2
    and liqapo.id_periodo = tab1.id_periodo
    and liqapo.id_tipo_doc = tab1.id_tipo_doc
    and liqapo.num_doc = tab1.num_doc
    
    left join no_mae_fondos maefon
    on maefon.id_mae_fondos = liqapo.id_mae_fondos

    )tab0

where tab0.anho_mes between $anho_mes_ini and $anho_mes_fin
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado $whereTipoNovKa                      

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select
tab0.*

    from(

    select
    tab1.*,
    tab2.codigo as codtip,
    tab2.descripcion as descripcion,
    tab2.codigo || ' - ' || tab2.descripcion as completo_tipka,
    tab3.nombre_apellido AS nombre_apellido,
    per.anho_mes,
    per.periodo,
    per.id_tipo_periodo,
    cpnka.id_concep_nomina,
    liqnom.num_dias as dias_liq,
    liqnom.valor_liquidado as valor_liq,
    maefon.codigo,
    maefon.razon_social,
    maefon.codigo || ' - ' || maefon.razon_social as eps_per

    from no_novedad_kardex tab1

    left join no_tip_nov_ka tab2
    on tab2.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join no_datos_funcionario_v tab3
    on tab3.id_tipo_doc = tab1.id_tipo_doc
    and tab3.num_doc = tab1.num_doc

    left join no_periodo_v per
    on per.id_periodo = tab1.id_periodo
    
    left join no_concep_ka cpnka
    on cpnka.id_tip_nov_ka = tab1.id_tip_nov_ka
    
    left join no_liquida_nomina liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    
    left join no_liquida_aporte liqapo
    on liqapo.id_clase_fondo = 2
    and liqapo.id_periodo = tab1.id_periodo
    and liqapo.id_tipo_doc = tab1.id_tipo_doc
    and liqapo.num_doc = tab1.num_doc
    
    left join no_mae_fondos maefon
    on maefon.id_mae_fondos = liqapo.id_mae_fondos

    )tab0

where tab0.anho_mes between $anho_mes_ini and $anho_mes_fin
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado $whereTipoNovKa  

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_causa_vacac] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
